import datetime

from libpurple_to_markdown.data import Message
from libpurple_to_markdown.markdown import format_messages

NOW = datetime.datetime.fromtimestamp(1_000_000_000, tz=datetime.UTC)


TEXT_1 = 'Hello  \n  \nWorld  \n  '

EXPECTED_1 = """# Test

---
## [[2001-09-09]]

2001-09-09 01:46:40 [[Test Sender]]:
> Hello
>
> World

2001-09-09 01:46:40 [[Test Sender]]:
> Hello
>
> World

"""


def test_whitespace_at_end_of_line():
    msg = Message(NOW, 'Test Sender', TEXT_1, 'Test Chat')
    result = format_messages([msg, msg], title='Test')
    assert result == EXPECTED_1
